/*
 *  Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

package org.apache.harmony.drlvm.tests.regression.h3228;

import junit.framework.TestCase;


/*  The test checks that the JIT correctly optimizes nested monenter/monexit
 *  pairs when they are enclosed into another monenter/monexit with the same
 *  synchronization object.
 *  The synchronized method sync_run() contains a synchronized statement which
 *  can be safely removed. The issue described in Harmony-3228 caused
 *  a crash during the JIT compilation stage.
 */
public class H3228 extends TestCase {

    public void test() {
        boolean b = false;
        for (int i = 0; i < 1000000000; i++) {
            b = sync_run();
        }
        System.out.println("Test passed");
    }

    public synchronized boolean sync_run() {
        boolean a = false;
        synchronized (this) {
            a = !a;
        }
        return a;
    }
}
